# Method: accounts.customers.listPurchasableOffers

- [HTTP request](https://docs.cloud.google.com/channel/docs/reference/rest/v1/accounts.customers/listPurchasableOffers#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/channel/docs/reference/rest/v1/accounts.customers/listPurchasableOffers#body.PATH_PARAMETERS)
- [Query parameters](https://docs.cloud.google.com/channel/docs/reference/rest/v1/accounts.customers/listPurchasableOffers#body.QUERY_PARAMETERS)
- [Request body](https://docs.cloud.google.com/channel/docs/reference/rest/v1/accounts.customers/listPurchasableOffers#body.request_body)
- [Response body](https://docs.cloud.google.com/channel/docs/reference/rest/v1/accounts.customers/listPurchasableOffers#body.response_body)
  - [JSON representation](https://docs.cloud.google.com/channel/docs/reference/rest/v1/accounts.customers/listPurchasableOffers#body.ListPurchasableOffersResponse.SCHEMA_REPRESENTATION)
- [Authorization scopes](https://docs.cloud.google.com/channel/docs/reference/rest/v1/accounts.customers/listPurchasableOffers#body.aspect)
- [CreateEntitlementPurchase](https://docs.cloud.google.com/channel/docs/reference/rest/v1/accounts.customers/listPurchasableOffers#CreateEntitlementPurchase)
  - [JSON representation](https://docs.cloud.google.com/channel/docs/reference/rest/v1/accounts.customers/listPurchasableOffers#CreateEntitlementPurchase.SCHEMA_REPRESENTATION)
- [ChangeOfferPurchase](https://docs.cloud.google.com/channel/docs/reference/rest/v1/accounts.customers/listPurchasableOffers#ChangeOfferPurchase)
  - [JSON representation](https://docs.cloud.google.com/channel/docs/reference/rest/v1/accounts.customers/listPurchasableOffers#ChangeOfferPurchase.SCHEMA_REPRESENTATION)
- [PurchasableOffer](https://docs.cloud.google.com/channel/docs/reference/rest/v1/accounts.customers/listPurchasableOffers#PurchasableOffer)
  - [JSON representation](https://docs.cloud.google.com/channel/docs/reference/rest/v1/accounts.customers/listPurchasableOffers#PurchasableOffer.SCHEMA_REPRESENTATION)
- [Try it!](https://docs.cloud.google.com/channel/docs/reference/rest/v1/accounts.customers/listPurchasableOffers#try-it)

Lists the following:

- Offers that you can purchase for a customer.
- Offers that you can change for an entitlement.

Possible error codes:

- PERMISSION_DENIED:
  - The customer doesn't belong to the reseller
  - The reseller is not authorized to transact on this Product. See <https://support.google.com/channelservices/answer/9759265>
- INVALID_ARGUMENT: Required request parameters are missing or invalid.

### HTTP request

`GET https://cloudchannel.googleapis.com/v1/{customer=accounts/*/customers/*}:listPurchasableOffers`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `customer` | `string` Required. The resource name of the customer to list Offers for. Format: accounts/{account_id}/customers/{customer_id}. |

### Query parameters

| Parameters ||
|---|---|
| `pageSize` | `integer` Optional. Requested page size. Server might return fewer results than requested. If unspecified, returns at most 100 Offers. The maximum value is 1000; the server will coerce values above 1000. |
| `pageToken` | `string` Optional. A token for a page of results other than the first page. |
| `languageCode` | `string` Optional. The BCP-47 language code. For example, "en-US". The response will localize in the corresponding language code, if specified. The default value is "en-US". |
| Union parameter `purchase_option`. Defines the intended purchase. `purchase_option` can be only one of the following: ||
| `createEntitlementPurchase` | ``object (`https://docs.cloud.google.com/channel/docs/reference/rest/v1/accounts.customers/listPurchasableOffers#CreateEntitlementPurchase`)`` List Offers for CreateEntitlement purchase. |
| `changeOfferPurchase` | ``object (`https://docs.cloud.google.com/channel/docs/reference/rest/v1/accounts.customers/listPurchasableOffers#ChangeOfferPurchase`)`` List Offers for ChangeOffer purchase. |

### Request body

The request body must be empty.

### Response body

Response message for customers.listPurchasableOffers.

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "purchasableOffers": [ { object (`https://docs.cloud.google.com/channel/docs/reference/rest/v1/accounts.customers/listPurchasableOffers#PurchasableOffer`) } ], "nextPageToken": string } ``` |

| Fields ||
|---|---|
| `purchasableOffers[]` | ``object (`https://docs.cloud.google.com/channel/docs/reference/rest/v1/accounts.customers/listPurchasableOffers#PurchasableOffer`)`` The list of Offers requested. |
| `nextPageToken` | `string` A token to retrieve the next page of results. |

### Authorization scopes

Requires the following OAuth scope:

- `https://www.googleapis.com/auth/apps.order`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).

## CreateEntitlementPurchase

List Offers for CreateEntitlement purchase.

| JSON representation |
|---|
| ``` { "sku": string, "billingAccount": string } ``` |

| Fields ||
|---|---|
| `sku` | `string` Required. SKU that the result should be restricted to. Format: products/{productId}/skus/{skuId}. |
| `billingAccount` | `string` Optional. Billing account that the result should be restricted to. Format: accounts/{account_id}/billingAccounts/{billing_account_id}. |

## ChangeOfferPurchase

List Offers for ChangeOffer purchase.

| JSON representation |
|---|
| ``` { "entitlement": string, "newSku": string, "billingAccount": string } ``` |

| Fields ||
|---|---|
| `entitlement` | `string` Required. Resource name of the entitlement. Format: accounts/{account_id}/customers/{customer_id}/entitlements/{entitlement_id} |
| `newSku` | `string` Optional. Resource name of the new target SKU. Provide this SKU when upgrading or downgrading an entitlement. Format: products/{productId}/skus/{skuId} |
| `billingAccount` | `string` Optional. Resource name of the new target Billing Account. Provide this Billing Account when setting up billing for a trial subscription. Format: accounts/{account_id}/billingAccounts/{billing_account_id}. This field is only relevant for multi-currency accounts. It should be left empty for single currency accounts. |

## PurchasableOffer

Offer that you can purchase for a customer. This is used in the ListPurchasableOffer API response.

| JSON representation |
|---|
| ``` { "offer": { object (`https://docs.cloud.google.com/channel/docs/reference/rest/v1/Offer`) }, "priceReferenceId": string } ``` |

| Fields ||
|---|---|
| `offer` | ``object (`https://docs.cloud.google.com/channel/docs/reference/rest/v1/Offer`)`` Offer. |
| `priceReferenceId` | `string` Optional. Price reference ID for the offer. Only for offers that require additional price information. Used to guarantee that the pricing is consistent between quoting the offer and placing the order. |